Designing Data-Intensive Applications
=====================================

Chapter 1 References
--------------------

1.  Michael Stonebraker and Uğur Çetintemel:
    “['One Size Fits All': An Idea Whose Time Has Come and Gone](http://citeseerx.ist.psu.edu/viewdoc/download?doi=10.1.1.68.9136&rep=rep1&type=pdf),” at *21st International Conference
    on Data Engineering* (ICDE), April 2005.

1.  Walter L. Heimerdinger and Charles B. Weinstock:
    “[A Conceptual Framework for System Fault Tolerance](http://www.sei.cmu.edu/reports/92tr033.pdf),” Technical Report CMU/SEI-92-TR-033, Software Engineering Institute, Carnegie
    Mellon University, October 1992.

1.  Ding Yuan, Yu Luo, Xin Zhuang, et al.:
    “[Simple Testing Can Prevent Most Critical Failures: An Analysis of Production Failures in Distributed Data-Intensive Systems](https://www.usenix.org/system/files/conference/osdi14/osdi14-paper-yuan.pdf),” at *11th USENIX Symposium on Operating Systems Design
    and Implementation* (OSDI), October 2014.

1.  Yury Izrailevsky and Ariel Tseitlin:
    “[The Netflix Simian Army](http://techblog.netflix.com/2011/07/netflix-simian-army.html),”
    *techblog.netflix.com*, July 19, 2011.

1.  Daniel Ford, François Labelle, Florentina I. Popovici, et al.:
    “[Availability in Globally Distributed Storage Systems](http://research.google.com/pubs/archive/36737.pdf),”
    at *9th USENIX Symposium on Operating Systems Design and Implementation* (OSDI),
    October 2010.

1.  Brian Beach:
    “[Hard Drive Reliability Update – Sep 2014](https://www.backblaze.com/blog/hard-drive-reliability-update-september-2014/),” *backblaze.com*, September 23, 2014.

1.  Laurie Voss:
    “[AWS: The Good, the Bad and the Ugly](https://web.archive.org/web/20160429075023/http://blog.awe.sm/2012/12/18/aws-the-good-the-bad-and-the-ugly/),” *blog.awe.sm*, December 18, 2012.

1.  Haryadi S. Gunawi, Mingzhe Hao, Tanakorn
    Leesatapornwongsa, et al.: “[What Bugs Live in the Cloud?](http://ucare.cs.uchicago.edu/pdf/socc14-cbs.pdf),” at *5th ACM Symposium on Cloud Computing* (SoCC), November 2014.
    [doi:10.1145/2670979.2670986](http://dx.doi.org/10.1145/2670979.2670986)

1.  Nelson Minar:
      “[Leap Second Crashes Half   the Internet](http://www.somebits.com/weblog/tech/bad/leap-second-2012.html),” *somebits.com*, July 3, 2012.

1.  Amazon Web Services:
      “[Summary of the Amazon EC2 and Amazon RDS Service   Disruption in the US East Region](http://aws.amazon.com/message/65648/),” *aws.amazon.com*, April 29, 2011.

1.  Richard I. Cook:
    “[How Complex Systems Fail](http://web.mit.edu/2.75/resources/random/How%20Complex%20Systems%20Fail.pdf),” Cognitive Technologies Laboratory, April 2000.

1.  Jay Kreps:
    “[Getting Real About Distributed System Reliability](http://blog.empathybox.com/post/19574936361/getting-real-about-distributed-system-reliability),” *blog.empathybox.com*, March 19, 2012.

1.  David Oppenheimer, Archana Ganapathi, and David A. Patterson:
    “[Why Do Internet Services Fail, and What Can Be Done About It?](http://static.usenix.org/legacy/events/usits03/tech/full_papers/oppenheimer/oppenheimer.pdf),” at *4th USENIX Symposium on
    Internet Technologies and Systems* (USITS), March 2003.

1.  Nathan Marz:
      “[Principles   of Software Engineering, Part 1](http://nathanmarz.com/blog/principles-of-software-engineering-part-1.html),” *nathanmarz.com*, April 2, 2013.

1.  Michael Jurewitz:
    “[The Human Impact of Bugs](http://jury.me/blog/2013/3/14/the-human-impact-of-bugs),”
    *jury.me*, March 15, 2013.

1.  Raffi Krikorian:
    “[Timelines at Scale](http://www.infoq.com/presentations/Twitter-Timeline-Scalability),”
    at *QCon San Francisco*, November 2012.

1.  Martin Fowler:
    *Patterns of Enterprise Application Architecture*. Addison Wesley, 2002.
    ISBN: 978-0-321-12742-6

1.  Kelly Sommers:
    “[After all that run around, what caused 500ms disk latency even when we replaced physical server?](https://twitter.com/kellabyte/status/532930540777635840)” *twitter.com*, November 13, 2014.

1.  Giuseppe DeCandia, Deniz Hastorun, Madan Jampani, et al.:
    “[Dynamo: Amazon's Highly Available Key-Value Store](http://www.allthingsdistributed.com/files/amazon-dynamo-sosp2007.pdf),” at *21st ACM Symposium on Operating
    Systems Principles* (SOSP), October 2007.

1.  Greg Linden:
    “[Make Data Useful](http://glinden.blogspot.co.uk/2006/12/slides-from-my-talk-at-stanford.html),” slides from presentation at Stanford University Data Mining class (CS345), December 2006.

1.  Tammy Everts:
    “[The Real Cost of Slow Time vs Downtime](http://www.webperformancetoday.com/2014/11/12/real-cost-slow-time-vs-downtime-slides/),” *webperformancetoday.com*, November 12, 2014.

1.  Jake Brutlag:
    “[Speed Matters for Google Web Search](http://googleresearch.blogspot.co.uk/2009/06/speed-matters.html),” *googleresearch.blogspot.co.uk*, June 22, 2009.

1.  Tyler Treat:
    “[Everything You Know About Latency Is Wrong](http://bravenewgeek.com/everything-you-know-about-latency-is-wrong/),” *bravenewgeek.com*, December 12, 2015.

1.  Jeffrey Dean and Luiz André Barroso:
    “[The Tail at Scale](http://cacm.acm.org/magazines/2013/2/160173-the-tail-at-scale/fulltext),”
    *Communications of the ACM*, volume 56, number 2, pages 74–80, February 2013.
    [doi:10.1145/2408776.2408794](http://dx.doi.org/10.1145/2408776.2408794)

1.  Graham Cormode, Vladislav
    Shkapenyuk, Divesh Srivastava, and Bojian Xu:
    “[Forward Decay: A Practical Time Decay Model for Streaming Systems](http://dimacs.rutgers.edu/~graham/pubs/papers/fwddecay.pdf),” at *25th IEEE International Conference on Data
    Engineering* (ICDE), March 2009.

1.  Ted Dunning and Otmar Ertl:
    “[Computing Extremely Accurate Quantiles Using t-Digests](https://github.com/tdunning/t-digest),” *github.com*, March 2014.

1.  Gil Tene:
    “[HdrHistogram](http://www.hdrhistogram.org/),” *hdrhistogram.org*.

1.  Baron Schwartz:
    “[Why Percentiles Don’t Work the Way You Think](https://www.vividcortex.com/blog/why-percentiles-dont-work-the-way-you-think),” *vividcortex.com*, December 7, 2015.

1.  James Hamilton:
    “[On Designing and Deploying Internet-Scale Services](https://www.usenix.org/legacy/events/lisa07/tech/full_papers/hamilton/hamilton.pdf),” at *21st Large Installation
    System Administration Conference* (LISA), November 2007.

1.  Brian Foote and Joseph Yoder:
    “[Big Ball of Mud](http://www.laputan.org/pub/foote/mud.pdf),” at
    *4th Conference on Pattern Languages of Programs* (PLoP),
    September 1997.

1.  Frederick P Brooks: “No Silver Bullet – Essence and
    Accident in Software Engineering,” in *The Mythical Man-Month*, Anniversary
    edition, Addison-Wesley, 1995. ISBN: 978-0-201-83595-3

1.  Ben Moseley and Peter Marks:
    “[Out of the Tar Pit](http://citeseerx.ist.psu.edu/viewdoc/summary?doi=10.1.1.93.8928),”
    at *BCS Software Practice Advancement* (SPA), 2006.

1.  Rich Hickey:
    “[Simple Made Easy](http://www.infoq.com/presentations/Simple-Made-Easy),”
    at *Strange Loop*, September 2011.

1.  Hongyu Pei Breivold, Ivica Crnkovic, and Peter J. Eriksson:
    “[Analyzing Software Evolvability](http://www.mrtc.mdh.se/publications/1478.pdf),”
    at *32nd Annual IEEE International Computer Software and Applications Conference*
    (COMPSAC), July 2008.
    [doi:10.1109/COMPSAC.2008.50](http://dx.doi.org/10.1109/COMPSAC.2008.50)

