Designing Data-Intensive Applications
=====================================

Chapter 7 References
--------------------

1.  Donald D. Chamberlin, Morton M. Astrahan, Michael W. Blasgen, et al.:
    “[A History and Evaluation of System R](http://citeseerx.ist.psu.edu/viewdoc/download?doi=10.1.1.84.348&rep=rep1&type=pdf),” *Communications of the ACM*,
    volume 24, number 10, pages 632–646, October 1981.
    [doi:10.1145/358769.358784](http://dx.doi.org/10.1145/358769.358784)

1.  Jim N. Gray, Raymond A. Lorie, Gianfranco R. Putzolu, and Irving L. Traiger:
    “[Granularity of Locks and Degrees of Consistency in a Shared Data Base](http://citeseer.ist.psu.edu/viewdoc/download?doi=10.1.1.92.8248&rep=rep1&type=pdf),” in *Modelling in Data
    Base Management Systems: Proceedings of the IFIP Working Conference on Modelling in Data Base
    Management Systems*, edited by G. M. Nijssen, pages
    364–394, Elsevier/North Holland Publishing, 1976. Also in *Readings in Database Systems*, 4th edition, edited by Joseph M.
    Hellerstein and Michael Stonebraker, MIT Press, 2005. ISBN: 978-0-262-69314-1

1.  Kapali P. Eswaran, Jim N. Gray, Raymond A. Lorie, and Irving L. Traiger:
    “[The Notions of Consistency and Predicate Locks in a Database System](http://research.microsoft.com/en-us/um/people/gray/papers/On%20the%20Notions%20of%20Consistency%20and%20Predicate%20Locks%20in%20a%20Database%20System%20CACM.pdf),” *Communications of the
    ACM*, volume 19, number 11, pages 624–633, November 1976.

1.  “[ACID Transactions Are Incredibly Helpful](http://web.archive.org/web/20150320053809/https://foundationdb.com/acid-claims),” FoundationDB, LLC, 2013.

1.  John D. Cook:
    “[ACID Versus BASE for Database Transactions](http://www.johndcook.com/blog/2009/07/06/brewer-cap-theorem-base/),” *johndcook.com*, July 6, 2009.

1.  Gavin Clarke:
    “[NoSQL's CAP Theorem Busters: We Don't Drop ACID](http://www.theregister.co.uk/2012/11/22/foundationdb_fear_of_cap_theorem/),” *theregister.co.uk*, November 22, 2012.

1.  Theo Härder and Andreas Reuter:
    “[Principles of Transaction-Oriented Database Recovery](http://citeseerx.ist.psu.edu/viewdoc/download?doi=10.1.1.87.2812&rep=rep1&type=pdf),” *ACM Computing Surveys*,
    volume 15, number 4, pages 287–317, December 1983.
    [doi:10.1145/289.291](http://dx.doi.org/10.1145/289.291)

1.  Peter Bailis, Alan Fekete, Ali Ghodsi, et al.:
    “[HAT, not CAP: Towards Highly Available Transactions](http://www.bailis.org/papers/hat-hotos2013.pdf),”
    at *14th USENIX Workshop on Hot Topics in Operating Systems* (HotOS), May 2013.

1.  Armando Fox, Steven D. Gribble, Yatin Chawathe, et al.:
    “[Cluster-Based Scalable Network Services](http://www.cs.berkeley.edu/~brewer/cs262b/TACC.pdf),” at
    *16th ACM Symposium on Operating Systems Principles* (SOSP), October 1997.

1.  Philip A. Bernstein, Vassos Hadzilacos, and Nathan Goodman:
    <a href="http://research.microsoft.com/en-us/people/philbe/ccontrol.aspx">*Concurrency
    Control and Recovery in Database Systems*</a>. Addison-Wesley, 1987. ISBN: 978-0-201-10715-9,
    available online at *research.microsoft.com*.

1.  Alan Fekete, Dimitrios Liarokapis, Elizabeth O'Neil, et al.:
    “[Making Snapshot Isolation Serializable](https://www.cse.iitb.ac.in/infolab/Data/Courses/CS632/2009/Papers/p492-fekete.pdf),” *ACM Transactions on Database Systems*,
    volume 30, number 2, pages 492–528, June 2005.
    [doi:10.1145/1071610.1071615](http://dx.doi.org/10.1145/1071610.1071615)

1.  Mai Zheng, Joseph Tucek, Feng Qin, and Mark Lillibridge:
      “[Understanding   the Robustness of SSDs Under Power Fault](https://www.usenix.org/system/files/conference/fast13/fast13-final80.pdf),” at *11th USENIX Conference on File and
      Storage Technologies* (FAST), February 2013.

1.  Laurie Denness:
      “[SSDs: A Gift and a Curse](https://laur.ie/blog/2015/06/ssds-a-gift-and-a-curse/),”
      *laur.ie*, June 2, 2015.

1.  Adam Surak:
      “[When Solid State   Drives Are Not That Solid](https://blog.algolia.com/when-solid-state-drives-are-not-that-solid/),” *blog.algolia.com*, June 15, 2015.

1.  Thanumalayan Sankaranarayana Pillai, Vijay Chidambaram,
      Ramnatthan Alagappan, et al.: “[All   File Systems Are Not Created Equal: On the Complexity of Crafting Crash-Consistent Applications](http://research.cs.wisc.edu/wind/Publications/alice-osdi14.pdf),”
      at *11th USENIX Symposium on Operating Systems Design and Implementation* (OSDI),
      October 2014.

1.  Chris Siebenmann:
      “[Unix's File Durability   Problem](https://utcc.utoronto.ca/~cks/space/blog/unix/FileSyncProblem),” *utcc.utoronto.ca*, April 14, 2016.

1.  Lakshmi N. Bairavasundaram, Garth R.
      Goodson, Bianca Schroeder, et al.:
      “[An Analysis of Data   Corruption in the Storage Stack](http://research.cs.wisc.edu/adsl/Publications/corruption-fast08.pdf),” at *6th USENIX Conference on File and Storage
      Technologies* (FAST), February 2008.

1.  Bianca Schroeder, Raghav Lagisetty, and Arif Merchant:
      “[Flash   Reliability in Production: The Expected and the Unexpected](https://www.usenix.org/conference/fast16/technical-sessions/presentation/schroeder),” at *14th USENIX Conference on
      File and Storage Technologies* (FAST), February 2016.

1.  Don Allison:
      “[SSD Storage – Ignorance of Technology Is No   Excuse](https://blog.korelogic.com/blog/2015/03/24),” *blog.korelogic.com*, March 24, 2015.

1.  Dave Scherer:
    “[Those Are Not Transactions (Cassandra 2.0)](http://web.archive.org/web/20150526065247/http://blog.foundationdb.com/those-are-not-transactions-cassandra-2-0),” *blog.foundationdb.com*, September 6, 2013.

1.  Kyle Kingsbury:
    “[Call Me Maybe: Cassandra](http://aphyr.com/posts/294-call-me-maybe-cassandra/),”
    *aphyr.com*, September 24, 2013.

1.  “[ACID Support in Aerospike](http://www.aerospike.com/docs/architecture/assets/AerospikeACIDSupport.pdf),” Aerospike, Inc., June 2014.

1.  Martin Kleppmann:
    “[Hermitage: Testing the 'I' in ACID](http://martin.kleppmann.com/2014/11/25/hermitage-testing-the-i-in-acid.html),” *martin.kleppmann.com*, November 25, 2014.

1.  Tristan D'Agosta:
    “[BTC Stolen from Poloniex](https://bitcointalk.org/index.php?topic=499580),”
    *bitcointalk.org*, March 4, 2014.

1.  bitcointhief2:
    “[How I Stole Roughly 100 BTC from an Exchange and How I Could Have Stolen More!](http://www.reddit.com/r/Bitcoin/comments/1wtbiu/how_i_stole_roughly_100_btc_from_an_exchange_and/),” *reddit.com*,
    February 2, 2014.

1.  Sudhir Jorwekar, Alan Fekete, Krithi Ramamritham, and S. Sudarshan:
    “[Automating the Detection of Snapshot Isolation Anomalies](http://www.vldb.org/conf/2007/papers/industrial/p1263-jorwekar.pdf),” at *33rd International Conference on
    Very Large Data Bases* (VLDB), September 2007.

1.  Michael Melanson:
    “[Transactions: The Limits of Isolation](http://www.michaelmelanson.net/2014/03/20/transactions/),” *michaelmelanson.net*, March 20, 2014.

1.  Hal Berenson, Philip A. Bernstein, Jim N. Gray, et al.:
    “[A Critique of ANSI SQL Isolation Levels](http://research.microsoft.com/pubs/69541/tr-95-51.pdf),”
    at *ACM International Conference on Management of Data* (SIGMOD), May 1995.

1.  Atul Adya: “[Weak Consistency: A Generalized Theory and Optimistic Implementations for Distributed Transactions](http://pmg.csail.mit.edu/papers/adya-phd.pdf),”
    PhD Thesis, Massachusetts Institute of Technology, March 1999.

1.  Peter Bailis, Aaron Davidson, Alan Fekete, et al.:
    “[Highly Available Transactions: Virtues and Limitations (Extended Version)](http://arxiv.org/pdf/1302.0309.pdf),” at *40th International Conference on Very Large Data Bases*
    (VLDB), September 2014.

1.  Bruce Momjian:
    “[MVCC Unmasked](http://momjian.us/main/presentations/internals.html#mvcc),” *momjian.us*,
    July 2014.

1.  Annamalai Gurusami:
    “[Repeatable Read Isolation Level in InnoDB – How Consistent Read View Works](https://blogs.oracle.com/mysqlinnodb/entry/repeatable_read_isolation_level_in),” *blogs.oracle.com*,
    January 15, 2013.

1.  Nikita Prokopov:
    “[Unofficial Guide to Datomic Internals](http://tonsky.me/blog/unofficial-guide-to-datomic-internals/),” *tonsky.me*, May 6, 2014.

1.  Baron Schwartz:
    “[Immutability, MVCC, and Garbage Collection](http://www.xaprb.com/blog/2013/12/28/immutability-mvcc-and-garbage-collection/),” *xaprb.com*, December 28, 2013.

1.  J. Chris Anderson, Jan Lehnardt, and Noah Slater:
    *CouchDB: The Definitive Guide*. O'Reilly Media, 2010.
    ISBN: 978-0-596-15589-6

1.  Rikdeb Mukherjee:
    “[Isolation in DB2 (Repeatable Read, Read Stability, Cursor Stability, Uncommitted Read) with Examples](http://mframes.blogspot.co.uk/2013/07/isolation-in-cursor.html),”
    *mframes.blogspot.co.uk*, July 4, 2013.

1.  Steve Hilker:
    “[Cursor Stability (CS) – IBM DB2 Community](http://www.toadworld.com/platforms/ibmdb2/w/wiki/6661.cursor-stability-cs.aspx),” *toadworld.com*, March 14, 2013.

1.  Nate Wiger:
    “[An Atomic Rant](http://www.nateware.com/an-atomic-rant.html),” *nateware.com*,
    February 18, 2010.

1.  Joel Jacobson:
    “[Riak 2.0: Data Types](http://blog.joeljacobson.com/riak-2-0-data-types/),”
    *blog.joeljacobson.com*, March 23, 2014.

1.  Michael J. Cahill, Uwe Röhm, and Alan Fekete:
    “[Serializable Isolation for Snapshot Databases](http://www.cs.nyu.edu/courses/fall12/CSCI-GA.2434-001/p729-cahill.pdf),” at *ACM International Conference on
    Management of Data* (SIGMOD), June 2008.
    [doi:10.1145/1376616.1376690](http://dx.doi.org/10.1145/1376616.1376690)

1.  Dan R. K. Ports and Kevin Grittner:
    “[Serializable Snapshot Isolation in PostgreSQL](http://drkp.net/papers/ssi-vldb12.pdf),”
    at *38th International Conference on Very Large Databases* (VLDB), August 2012.

1.  Tony Andrews:
      “[Enforcing   Complex Constraints in Oracle](http://tonyandrews.blogspot.co.uk/2004/10/enforcing-complex-constraints-in.html),” *tonyandrews.blogspot.co.uk*, October 15, 2004.

1.  Douglas B. Terry, Marvin M. Theimer, Karin Petersen, et al.:
      “[Managing   Update Conflicts in Bayou, a Weakly Connected Replicated Storage System](http://citeseerx.ist.psu.edu/viewdoc/download?doi=10.1.1.141.7889&rep=rep1&type=pdf),” at
      *15th ACM Symposium on Operating Systems Principles* (SOSP), December 1995.
      [doi:10.1145/224056.224070](http://dx.doi.org/10.1145/224056.224070)

1.  Gary Fredericks:
      “[Postgres Serializability   Bug](https://github.com/gfredericks/pg-serializability-bug),” *github.com*, September 2015.

1.  Michael Stonebraker, Samuel Madden, Daniel J. Abadi, et al.:
    “[The End of an Architectural Era (It’s Time for a Complete Rewrite)](http://citeseerx.ist.psu.edu/viewdoc/download?doi=10.1.1.137.3697&rep=rep1&type=pdf),” at *33rd International
    Conference on Very Large Data Bases* (VLDB), September 2007.

1.  John Hugg:
    “[H-Store/VoltDB Architecture vs. CEP Systems and Newer Streaming Architectures](https://www.youtube.com/watch?v=hD5M4a1UVz8),” at *Data @Scale Boston*,
    November 2014.

1.  Robert Kallman, Hideaki Kimura, Jonathan Natkins, et al.:
    “[H-Store: A High-Performance, Distributed Main Memory Transaction Processing System](http://www.vldb.org/pvldb/1/1454211.pdf),” *Proceedings of the VLDB
    Endowment*, volume 1, number 2, pages 1496–1499, August 2008.

1.  Rich Hickey:
    “[The Architecture of Datomic](http://www.infoq.com/articles/Architecture-Datomic),” *infoq.com*, November 2, 2012.

1.  John Hugg:
    “[Debunking Myths About the VoltDB In-Memory Database](http://voltdb.com/blog/debunking-myths-about-voltdb-memory-database),” *voltdb.com*, May 12, 2014.

1.  Joseph M. Hellerstein, Michael Stonebraker, and James Hamilton:
    “[Architecture of a Database System](http://db.cs.berkeley.edu/papers/fntdb07-architecture.pdf),”
    *Foundations and Trends in Databases*, volume 1, number 2, pages 141–259, November 2007.
    [doi:10.1561/1900000002](http://dx.doi.org/10.1561/1900000002)

1.  Michael J. Cahill:
    “[Serializable Isolation for Snapshot Databases](http://cahill.net.au/wp-content/uploads/2010/02/cahill-thesis.pdf),” PhD Thesis, University of Sydney, July 2009.

1.  D. Z. Badal:
    “[Correctness of Concurrency Control and Implications in Distributed Databases](http://ieeexplore.ieee.org/abstract/document/762563/),” at *3rd International IEEE Computer Software and
    Applications Conference* (COMPSAC), November 1979.

1.  Rakesh Agrawal, Michael J. Carey, and Miron Livny:
    “[Concurrency Control Performance Modeling: Alternatives and Implications](http://www.eecs.berkeley.edu/~brewer/cs262/ConcControl.pdf),” *ACM Transactions on Database
    Systems* (TODS), volume 12, number 4, pages 609–654, December 1987.
    [doi:10.1145/32204.32220](http://dx.doi.org/10.1145/32204.32220)

1.  Dave Rosenthal:
    “[Databases at 14.4MHz](http://web.archive.org/web/20150427041746/http://blog.foundationdb.com/databases-at-14.4mhz),”
    *blog.foundationdb.com*, December 10, 2014.

